unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CommHandle : hFile;
  DCB : TDCB;
  PortString: string;
  CommTimeOuts: TCOMMTIMEOUTS;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
PortString := '\\.\COM' + Edit1.Text;
CommHandle := CreateFile(PChar(PortString), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING,
         0, 0);

if (CommHandle = INVALID_HANDLE_VALUE) then
begin
  MessageDlg('Error. Can`t Open port', mtError, [mbOK], 0);
end
else
begin
  GetCommState(CommHandle, DCB);
  DCB.BaudRate  := CBR_9600; // FORMALLY, CONNECT BAUD DOESN`T MATTER (Virtual Com Port)
  DCB.Parity    := NOPARITY;
  DCB.ByteSize  := 8;
  DCB.StopBits  := OneStopBit;   

  CommTimeOuts.ReadIntervalTimeout          := 0;
  CommTimeOuts.ReadTotalTimeoutMultiplier   := 0;
  CommTimeOuts.ReadTotalTimeoutConstant     := 1000;
  CommTimeOuts.WriteTotalTimeoutMultiplier  := 0;
  CommTimeOuts.WriteTotalTimeoutConstant    := 1000;
  SetCommTimeouts(CommHandle, CommTimeOuts);
  SetCommState(CommHandle, DCB);

  MessageDlg('Port Open Ok', mtInformation, [mbOK], 0);
end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
Buf: string;
CRbyte: Shortint;
LFbyte: Shortint;
NumberWritten : DWORD;

begin
CRbyte := 13; // HEX 0x0D
LFbyte := 10; // HEX 0x0A

if (Length(Edit2.Text) <= 0) then
begin
   MessageDlg('No Data to write', mtError, [mbOK], 0);
   Exit;
end;

Buf := '$KE,UD,SET,' + Edit2.Text + Char(CRbyte) + Char(LFbyte);  
WriteFile(CommHandle, PChar(Buf)^, Length(Buf), NumberWritten, nil); 
MessageDlg('Data has been sended to module', mtInformation, [mbOK], 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
BinBuf: array[0..64] of Char;
Buf: string;
pBuf: array [0..64] of Char;
CRbyte: Shortint;
LFbyte: Shortint;
NumberWritten : DWORD;

begin
CRbyte := 13; // HEX 0x0D
LFbyte := 10; // HEX 0x0A

// Clear Port Buffers from previous data
PurgeComm(CommHandle, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);

Buf := '$KE,UD,GET' + Char(CRbyte) + Char(LFbyte);
WriteFile(CommHandle, PChar(Buf)^, Length(Buf), NumberWritten, nil);

// Make littele pause for wait module anser
Sleep(80); // Wait 80 ms

ReadFile(CommHandle, BinBuf, 128, NumberWritten, nil);
if(NumberWritten = 0) then
begin
  MessageDlg('Read Data Fail #1', mtError, [mbOK], 0);
  Exit;
end;

if(StrLComp(BinBuf, '#UD,NOTSET', 10) = 0) then
begin
  MessageDlg('Module is empty. No data at present.', mtInformation, [mbOK], 0);
  Exit;
end;
                                            
StrLCopy(pBuf, BinBuf + 4, NumberWritten - 4 - 2);  // Remove from string '#UD,' and <CR><LF>
MessageDlg(pBuf, mtInformation, [mbOK], 0); 
end;

end.
